
        INCLUDE \masm32\include\masm32rt.inc
        INCLUDE Optical.inc

;#########################################################################

GetCDHandle     PROTO   :DWORD
VerifyMedia     PROTO   :DWORD
GetOpticalType  PROTO   :DWORD

;#########################################################################

        .DATA

szAppName db "Optical Drive Test",0
szDrive   db "\\.\E:",0
szMsg1    db "CD Drive",0
szMsg2    db "DVD Drive",0
szMsg3    db "Nothing found",0
szMsg4    db "No CD/DVD Found",0
szMsg5    db "Cannot open drive",0

;-------------------------------------------------------------------------

        .DATA?

hDevice      dd ?
bDrive_CdDvd db ?

;#########################################################################

        .CODE

;-------------------------------------------------------------------------

GetCDHandle PROC    lpszDevice:DWORD

    xor     edx,edx
    INVOKE  CreateFile,lpszDevice,GENERIC_READ,FILE_SHARE_READ or FILE_SHARE_WRITE,edx,OPEN_EXISTING,edx,edx
    .if eax==INVALID_HANDLE_VALUE
        xor     eax,eax
    .endif
    mov     hDevice,eax
    ret

GetCDHandle ENDP

;-------------------------------------------------------------------------

VerifyMedia PROC    _hDevice:DWORD

        LOCAL   dwBytes:DWORD

    xor     edx,edx
    INVOKE  DeviceIoControl,_hDevice,IOCTL_STORAGE_CHECK_VERIFY2,edx,edx,edx,edx,addr dwBytes,edx
 ;   .if eax!=0
 ;       mov     eax,TRUE
 ;   .else
 ;       xor     eax,eax
 ;   .endif

    ret

VerifyMedia ENDP

;-------------------------------------------------------------------------

GetOpticalType PROC    _hDevice:DWORD

        LOCAL   dwBytes:DWORD
        LOCAL   pMediaTypes[2048]:BYTE

    xor     edx,edx
    mov     pMediaTypes.GET_MEDIA_TYPES.MediaInfoCount,1
    INVOKE  DeviceIoControl,_hDevice,IOCTL_STORAGE_GET_MEDIA_TYPES_EX,edx,edx,addr pMediaTypes,sizeof pMediaTypes,addr dwBytes,edx
    .if eax!=0
        lea     edi,pMediaTypes
        .if [edi].GET_MEDIA_TYPES.DeviceType==FILE_DEVICE_CD_ROM
            mov     bDrive_CdDvd,1
        .elseif [edi].GET_MEDIA_TYPES.DeviceType==FILE_DEVICE_DVD
            mov     bDrive_CdDvd,2
        .else
            mov     bDrive_CdDvd,0
        .endif
    .else
        xor     eax,eax
    .endif

    ret

GetOpticalType ENDP

;-------------------------------------------------------------------------

_main   PROC

    INVOKE  GetCDHandle,offset szDrive
    .if eax !=0
        INVOKE  VerifyMedia,hDevice
        .if eax==TRUE
            INVOKE  GetOpticalType,hDevice
            .if bDrive_CdDvd==1
                mov     edx,offset szMsg1
            .elseif bDrive_CdDvd==2
                mov     edx,offset szMsg2
            .else
                mov     edx,offset szMsg3
            .endif
        .else
            mov     edx,offset szMsg4
        .endif
    .else
        mov     edx,offset szMsg5
    .endif

    INVOKE  MessageBox,NULL,edx,offset szAppName,MB_OK
    mov     eax,hDevice
    or      eax,eax
    jz      ExitMain

    INVOKE  CloseHandle,eax

ExitMain:
    INVOKE  ExitProcess,0

_main   ENDP

;#########################################################################

        END     _main

