
;#########################################################################

IFNDEF STORAGE_MEDIA_TYPE
STORAGE_MEDIA_TYPE TYPEDEF DWORD
ENDIF

IFNDEF STORAGE_BUS_TYPE
STORAGE_BUS_TYPE   TYPEDEF DWORD
ENDIF

IFNDEF DEVICE_MEDIA_INFO
DEVICE_MEDIA_INFO STRUCT
  UNION DeviceSpecific
    STRUCT DiskInfo
      Cylinders            LARGE_INTEGER <>
      MediaType            STORAGE_MEDIA_TYPE ?
      TracksPerCylinder    DWORD ?
      SectorsPerTrack      DWORD ?
      BytesPerSector       DWORD ?
      NumberMediaSides     DWORD ?
      MediaCharacteristics DWORD ?
    ENDS
    STRUCT RemovableDiskInfo
      Cylinders            LARGE_INTEGER <>
      MediaType            STORAGE_MEDIA_TYPE ?
      TracksPerCylinder    DWORD ?
      SectorsPerTrack      DWORD ?
      BytesPerSector       DWORD ?
      NumberMediaSides     DWORD ?
      MediaCharacteristics DWORD ?
    ENDS
    STRUCT TapeInfo
      MediaType            STORAGE_MEDIA_TYPE ?
      MediaCharacteristics DWORD ?
      CurrentBlockSize     DWORD ?
      BusType              STORAGE_BUS_TYPE ?
      UNION BusSpecificData
        STRUCT ScsiInformation
          MediumType           BYTE ?
          DensityCode          BYTE ?
        ENDS
      ENDS
    ENDS
  ENDS
DEVICE_MEDIA_INFO ENDS
ENDIF

IFNDEF GET_MEDIA_TYPES
GET_MEDIA_TYPES STRUCT
  DeviceType      DWORD ?
  MediaInfoCount  DWORD ?
  MediaInfo       DEVICE_MEDIA_INFO <>
GET_MEDIA_TYPES ENDS
ENDIF

IFNDEF IOCTL_STORAGE_CHECK_VERIFY2
IOCTL_STORAGE_CHECK_VERIFY2      EQU 2D0800h
ENDIF

IFNDEF IOCTL_STORAGE_GET_MEDIA_TYPES_EX
IOCTL_STORAGE_GET_MEDIA_TYPES_EX EQU 2D0C04h
ENDIF

;#########################################################################

